OBJ
  stdio : "FullDuplexSerial"

PUB start
  stdio.start(31, 30, 0, 57600)
  
PUB putchar(val)
  stdio.tx(val)
  return val
  
PUB putdec(val, width)| temp
  temp := val
  if (val < 0)
    width--
    temp := -temp
  repeat while (temp > 9)
    width--
    temp /= 10
  repeat while (width-- > 1)
    putchar(" ")
  stdio.dec(val)
  
PUB puthex(val, width)
  if (width =< 0)
    width := 8
  stdio.hex(val, width)
  
PUB putstr(str)
  stdio.str(str)

PUB strcmp(str1, str2)
  IF (STRCOMP(str1, str2))
    RETURN 0
  REPEAT WHILE (BYTE[str1] AND BYTE[str1] == BYTE[str2])
    str1++
    str2++
  RETURN BYTE[str1] - BYTE[str2]

PUB strncmp(str1, str2, n)
  IF (n == 0)
    RETURN 0
  REPEAT WHILE (n-- AND BYTE[str1] AND BYTE[str1] == BYTE[str2])
    str1++
    str2++
  RETURN BYTE[str1] - BYTE[str2]

PUB memcpy(dest, src, n)
  BYTEMOVE(dest, src, n)
  RETURN dest

PUB memset(dest, val, n)
  BYTEFILL(dest, val, n)
  RETURN dest

PUB strcat(dst, src) | dlen, slen
  dlen := STRSIZE(dst)
  slen := STRSIZE(src) + 1
  BYTEMOVE(dst + dlen, src, slen)
  RETURN dst

PUB strcpy(dst, src) | slen
  slen := STRSIZE(src) + 1
  BYTEMOVE(dst, src, slen)
  RETURN dst

PUB memcmp(ptr1, ptr2, n)
  REPEAT WHILE (n-- > 0)
    IF (BYTE[ptr1] <> BYTE[ptr2])
      RETURN BYTE[ptr1] - BYTE[ptr2]
    ptr1++
    ptr2++
  RETURN 0

PUB printfx(arglist) | format, arg, width
  format := LONG[arglist][0]
  arg := LONG[arglist][1]
  arglist += 8
  REPEAT WHILE (BYTE[format])
    IF (BYTE[format] == "%")
      format++
      width := 0
      repeat while (byte[format] => "0" and byte[format] =< "9")
        width += (width * 10) + byte[format++] - "0"
      IF (BYTE[format] == "l")
        format++
      IF (BYTE[format] == 0)
        QUIT
      ELSEIF (BYTE[format] == "d" or byte[format] == "i")
        putdec(arg, width)
      ELSEIF (BYTE[format] == "s")
        putstr(arg)
      ELSEIF (BYTE[format] == "x")
        puthex(arg, width)
      ELSEIF (BYTE[format] == "c")
        putchar(arg)
      else
        putchar("%")
        NEXT
      format++
      arg := LONG[arglist]
      arglist += 4
    ELSEIF (BYTE[format] == 92)
      format++
      IF (BYTE[format] == 0)
        QUIT
      ELSEIF (BYTE[format] == "t")
        putchar(8)
      ELSEIF (BYTE[format] == "n")
        putchar(13)
      else
        putchar(BYTE[format])
      format++
    else
      putchar(BYTE[format++])

PUB printf0(format)
  printfx(@format)

PUB printf1(format, arg1) | arglist[2]
  arglist[0] := format
  arglist[1] := arg1
  printfx(@arglist)

PUB printf2(format, arg1, arg2) | arglist[3]
  arglist[0] := format
  arglist[1] := arg1
  arglist[2] := arg2
  printfx(@arglist)

PUB printf3(format, arg1, arg2, arg3) | arglist[4]
  arglist[0] := format
  arglist[1] := arg1
  arglist[2] := arg2
  arglist[3] := arg3
  printfx(@arglist)

PUB printf4(format, arg1, arg2, arg3, arg4) | arglist[5]
  arglist[0] := format
  arglist[1] := arg1
  arglist[2] := arg2
  arglist[3] := arg3
  arglist[4] := arg4
  printfx(@arglist)

PUB printf5(format, arg1, arg2, arg3, arg4, arg5) | arglist[6]
  arglist[0] := format
  arglist[1] := arg1
  arglist[2] := arg2
  arglist[3] := arg3
  arglist[4] := arg4
  arglist[5] := arg5
  printfx(@arglist)

PUB printf6(format, arg1, arg2, arg3, arg4, arg5, arg6) | arglist[7]
  arglist[0] := format
  arglist[1] := arg1
  arglist[2] := arg2
  arglist[3] := arg3
  arglist[4] := arg4
  arglist[5] := arg5
  arglist[6] := arg6
  printfx(@arglist)